if( SERVER ) then
	AddCSLuaFile( "shared.lua" );
end

if( CLIENT ) then
	SWEP.PrintName = "Fus Ro Dah";
	SWEP.Slot = 3;
	SWEP.SlotPos = 3;
	SWEP.DrawAmmo = false;
	SWEP.DrawCrosshair = true;
	SWEP.WepSelectIcon = null
end

SWEP.Author			= "KwestinMarkGames (music by sbeast64)"
SWEP.Instructions	= "Point and Push"
SWEP.Contact		= "booglyboot@hotmail.com"
SWEP.Purpose		= "Force Balance Push away whomever you want"

SWEP.ViewModelFOV	= 75
SWEP.ViewModelFlip	= false

SWEP.Spawnable			= false
SWEP.AdminSpawnable		= true

SWEP.NextStrike = 0;
  
SWEP.ViewModel      = ""
SWEP.WorldModel   = ""

  
-------------Primary Fire Attributes----------------------------------------
SWEP.Primary.Delay			= 5	--In seconds
SWEP.Primary.Recoil			= 5		--Gun Kick
SWEP.Primary.Damage			= 5	--Damage per Bullet
SWEP.Primary.NumShots		= 1		--Number of shots per one fire
SWEP.Primary.Cone			= 0 	--Bullet Spread
SWEP.Primary.ClipSize		= -1	--Use "-1 if there are no clips"
SWEP.Primary.DefaultClip	= -1	--Number of shots in next clip
SWEP.Primary.Automatic   	= false	--Pistol fire (false) or SMG fire (true)
SWEP.Primary.Ammo         	= "none"	--Ammo Type
 
util.PrecacheSound("player/shout/rodah.wav")
util.PrecacheSound("player/shout/fus.wav")
util.PrecacheSound("player/shout/epic.wav")

function SWEP:Initialize()
	if( SERVER ) then
			self:SetWeaponHoldType("normal");
	end
	self.Hit = { 
	Sound( "player/shout/rodah.wav" )};
	self.FleshHit = {
  	Sound( "player/shout/rodah.wav" ) } ;

end

function SWEP:Precache()
end

function SWEP:Deploy()
	self.Weapon:SendWeaponAnim( ACT_VM_IDLE );
	return true;
end

function SWEP:PrimaryAttack()
	 if( CurTime() < self.NextStrike ) then return; end
	 self.Weapon:EmitSound("player/shout/fus.wav")
	 self.NextStrike = ( CurTime() + 1 );
	 timer.Simple( 1.80, self.AttackAnim, self )
	 timer.Simple( 2.40, function() self.Weapon:SendWeaponAnim( ACT_VM_IDLE ) end)
     timer.Simple( 2.0, self.ShootBullets, self )
	 self.Owner:SetAnimation( PLAYER_ATTACK1 );
end	

function SWEP:ShootBullets()
	self.Weapon:EmitSound("");
 	local trace = self.Owner:GetEyeTrace();
	if trace.HitPos:Distance(self.Owner:GetShootPos()) <= 130 then
		if( trace.Entity:IsPlayer() or trace.Entity:IsNPC() or trace.Entity:GetClass()=="prop_ragdoll" ) then
				timer.Simple(0, game.ConsoleCommand, "host_timescale 0.5\n")
				timer.Simple(0.5, game.ConsoleCommand, "host_timescale 1\n")
			self.Owner:EmitSound( self.FleshHit[math.random(1,#self.FleshHit)] );
		else
			self.Owner:EmitSound( self.Hit[math.random(1,#self.Hit)] );
		end
				bullet = {}
				bullet.Num    = 5
				bullet.Src    = self.Owner:GetShootPos()
				bullet.Dir    = self.Owner:GetAimVector()
				bullet.Spread = Vector(0.04, 0.04, 0.04)
				bullet.Tracer = 0
				bullet.Force  = 100000000000
				bullet.Damage = 1000
			self.Owner:FireBullets(bullet)
	end
	
    if trace.Entity:GetClass() == "prop_door_rotating" then
     trace.Entity:EmitSound(Sound("physics/wood/wood_box_impact_hard3.wav"))
     trace.Entity:Fire("open", "", .001)
     trace.Entity:Fire("unlock", "", .001)
     local pos = trace.Entity:GetPos()
     local ang = trace.Entity:GetAngles()
     local model = trace.Entity:GetModel()
     local skin = trace.Entity:GetSkin()
     trace.Entity:SetNotSolid(true)
     trace.Entity:SetNoDraw(true)
     local function ResetDoor(door, fakedoor)
     door:SetNotSolid(false)
     door:SetNoDraw(false)
     fakedoor:Remove()
     end
     local norm = (pos - self.Owner:GetPos()):Normalize()
     local push = 10000000000 * norm
     local ent = ents.Create("prop_physics")
     ent:SetPos(pos)
     ent:SetAngles(ang)
     ent:SetModel(model)
    if(skin) then
      ent:SetSkin(skin)
    end
     ent:Spawn()
     timer.Simple(.01, ent.SetVelocity, ent, push)               
     timer.Simple(.01, ent:GetPhysicsObject().ApplyForceCenter, ent:GetPhysicsObject(), push)
	 timer.Simple(140, ResetDoor, trace.Entity, ent)
end

end

function SWEP:SecondaryAttack()
if( CurTime() < self.NextStrike ) then return; end
	self.Weapon:EmitSound("player/shout/epic.wav")
	self.NextStrike = ( CurTime() + 15.5 );
end

function SWEP:AttackAnim()
	self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK )
end 